program TypeCast;
uses HeapTrc, SysUtils;

function add (x,y : Double) : Double;
begin
   add := x + y;
end;
type
   TBaseClass = class
      procedure display;
   end;
   TDerivClass = class (TBaseClass)
      procedure display;
   end;
   
   procedure TBaseClass.display;
   begin
      WriteLn ('TBaseClass.display')
   end;
   procedure TDerivClass.display;
   begin
      WriteLn ('TDerivClass.display')
   end;
   
type
   TPositive = record
      PosNum : Double
   end;
   
   operator := (r : TPositive) : Double;
   begin
      Write ('[converting ',r.PosNum :0:1,' to Double]');
      result := r.PosNum
   end;
   
   operator := (r : Double) : TPositive;
   begin
      if r < 0 then raise Exception.Create ('TPositive: negative');
      Write ('[converting ',r :0:1,' to TPositive]');
      result.PosNum := r
   end;
      
var
   DerivObj : TDerivClass;
   num : TPositive;
   
begin
   WriteLn ('Type cast from Boolean to Integer:');
   WriteLn ('true = ', Integer (True), '; false = ', Integer (False));
   WriteLn ('Type cast from Boolean to Double:');
   WriteLn ('true = ', Double (True), '; false = ', Double (False));
   DerivObj := TDerivClass.Create;
   Write ('DerivObj: '); DerivObj.display;
   Write ('TBaseClass(DerivObj): '); TBaseClass(DerivObj).display;
   Write ('DerivObj as TBaseClass: '); (DerivObj as TBaseClass).display;
   //num := TPositive (2+TPositive(3));
   num := TPositive (add (2, TPositive(3)));
   WriteLn; WriteLn ('TPositive add (2, 3) = ', num.PosNum :0:1);
   DerivObj.Destroy
end.
   