{From http://wiki.freepascal.org/File_Handling_In_Pascal }
program FileTest;
{$I+} {Same as -Ci parameter to fpc.}
uses SysUtils;
var FileVar: TextFile;
begin
   WriteLn('File Test');
   AssignFile(FileVar, 'Test.txt');
   try  
      Rewrite(FileVar);  // creating the file  
      Writeln(FileVar,'Hello');
      CloseFile(FileVar);
   except
      on E: EInOutError do
      begin
         WriteLn('File handling error occurred. Details: ',
                 E.ClassName, '/', E.Message);
      end;    
   end;
   WriteLn('Program finished. Press enter to stop.');  
   ReadLn;
end.