program TestClass;
uses HeapTrc, SysUtils;
type TNode = class (TObject)
      head : Integer;
      tail : TNode;
      counter : Integer; static;
      constructor MyCreate (i : Integer);
      destructor Destroy; override;
      destructor MyDestroy;
   end;
   
   constructor TNode.MyCreate (i : Integer);
   begin
      head := i
   end;
   
   destructor TNode.MyDestroy;
   begin
      Inc (counter);
      WriteLn (counter, 'th destruction of head=', head);
   end;
   
   destructor TNode.Destroy;
   begin
      WriteLn ('default destruction of head=', head);
   end;

   procedure Test (s : String);
   var
      Node : TNode;
   begin
      if s = 'beta' then Node := nil;
      WriteLn ('is OK? ', Node = nil)
   end;
   
var
   Node1, Node2 : TNode;

begin
   Node1 := TNode.Create;
   Node2 := TNode.MyCreate(13);
   Node1.head := 7;
   Node1.tail := Node2;
   WriteLn (Node1.head, ', ', Node1.tail.head);
   Test ('alfa');
   Node1.Free; // Free just calls Destroy, if pointer is non-nil
   FreeAndNil (Node2)
end.